Imports Charmed.Container
Imports Charmed.Helpers
Imports Charmed.Messaging
Imports Charmed.Sample.Services

Namespace Charmed.Sample.ViewModels
	Public NotInheritable Class ViewModelLocator
		Public Sub New()
			Ioc.Container.Register(Of MainViewModel)()
			Ioc.Container.Register(Of FeedItemViewModel)()
			Ioc.Container.Register(Of ShellViewModel)()
			Ioc.Container.Register(Of IRssFeedService, RssFeedService)
			Ioc.Container.Register(Of ISerializer, Serializer)
			Ioc.Container.Register(Of INavigator, Navigator)
			Ioc.Container.Register(Of IShareManager, ShareManager)
			Ioc.Container.Register(Of ISecondaryPinner, SecondaryPinner)
			Ioc.Container.Register(Of ISettingsManager, SettingsManager)
			Ioc.Container.Register(Of ISettings, Settings)
			Ioc.Container.Register(Of IStorage, Storage)
			Ioc.Container.Register(Of SettingsViewModel)()
			Ioc.Container.RegisterInstance(Of IMessageBus)(New MessageBus)
			Ioc.Container.RegisterInstance(Of IContainer)(Ioc.Container)
		End Sub

		Public ReadOnly Property Main As MainViewModel
			Get
				Return Ioc.Container.Resolve(Of MainViewModel)()
			End Get
		End Property

		Public ReadOnly Property FeedItem As FeedItemViewModel
			Get
				Return Ioc.Container.Resolve(Of FeedItemViewModel)()
			End Get
		End Property

		Public ReadOnly Property Settings As SettingsViewModel
			Get
				Return Ioc.Container.Resolve(Of SettingsViewModel)()
			End Get
		End Property

		Public Shared ReadOnly Property IsInDesignMode As Boolean
			Get
				Return Windows.ApplicationModel.DesignMode.DesignModeEnabled
			End Get
		End Property
	End Class
End Namespace
