Imports System.IO
Imports System.Runtime.Serialization.Json
Imports System.Text
Imports System

Namespace Charmed
    Public NotInheritable Class Serializer
        Implements ISerializer

        Public Function Deserialize(ByVal type As Type, ByVal json As String) As Object Implements ISerializer.Deserialize
            Dim bytes As Object = Encoding.Unicode.GetBytes(System.Net.WebUtility.UrlDecode(json))
            Using stream As New MemoryStream
                Dim serializer As DataContractJsonSerializer = New DataContractJsonSerializer(type)
                Return serializer.ReadObject(stream)
            End Using
        End Function

        Public Function Deserialize(Of T)(ByVal json As String) As T Implements ISerializer.Deserialize
            Return CType(Deserialize(GetType(T), json), T)
        End Function

        Public Function Serialize(ByVal instance As Object) As String Implements ISerializer.Serialize
            If instance Is Nothing Then
                Throw New ArgumentNullException("instance")
            End If

            Using stream As New MemoryStream
                Dim serializer As DataContractJsonSerializer = New DataContractJsonSerializer(instance.GetType)
                serializer.WriteObject(stream, instance)
                stream.Position = 0
                Using reader As New StreamReader(stream)
                    Return System.Net.WebUtility.UrlEncode(reader.ReadToEnd)
                End Using
            End Using
        End Function
    End Class
End Namespace
