Imports Windows.UI.Popups
Imports Windows.UI.StartScreen
Imports System

Namespace Charmed
    Public NotInheritable Class TileInfo
        ''' <summary>
        ''' Constructor containing info for pinning a tile.
        ''' </summary>
        ''' <param name="tileId">The Id of the tile to pin</param>
        ''' <param name="shortName">The short name for the tile</param>
        ''' <param name="displayName">The display name for the tile</param>
        ''' <param name="tileOptions">The TileOptions for the tile</param>
        ''' <param name="logoUri">The Uri to the tile logo.</param>
        ''' <param name="arguments">Optional arguments to provide for when the tile is activated.</param>
        Public Sub New(ByVal tileId As String, ByVal shortName As String, ByVal displayName As String, ByVal tileOptions As TileOptions, ByVal logoUri As Uri, Optional ByVal arguments As String = Nothing)
            Me.TileId = tileId
            Me.ShortName = shortName
            Me.DisplayName = displayName
            Me.Arguments = arguments
            Me.TileOptions = tileOptions
            Me.LogoUri = logoUri
            Me.Arguments = arguments
        End Sub

        ''' <summary>
        ''' Constructor containing info for pinning a tile.
        ''' </summary>
        ''' <param name="tileId">The Id of the tile to pin</param>
        ''' <param name="shortName">The short name for the tile</param>
        ''' <param name="displayName">The display name for the tile</param>
        ''' <param name="tileOptions">The TileOptions for the tile</param>
        ''' <param name="logoUri">The Uri to the tile logo.</param>
        ''' <param name="wideLogoUri">The Uri to the wide tile logo.</param>
        ''' <param name="arguments">Optional arguments to provide for when the tile is activated.</param>
        Public Sub New(ByVal tileId As String, ByVal shortName As String, ByVal displayName As String, ByVal tileOptions As TileOptions, ByVal logoUri As Uri, ByVal wideLogoUri As Uri, Optional ByVal arguments As String = Nothing)
            Me.TileId = tileId
            Me.ShortName = shortName
            Me.DisplayName = displayName
            Me.Arguments = arguments
            Me.TileOptions = tileOptions
            Me.LogoUri = logoUri
            Me.WideLogoUri = wideLogoUri
            Me.Arguments = arguments
        End Sub

        Public Property TileId As String

        Public Property ShortName As String

        Public Property DisplayName As String

        Public Property Arguments As String

        Public Property TileOptions As TileOptions

        Public Property LogoUri As Uri

        Public Property WideLogoUri As Uri
    End Class
End Namespace
